/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the ChangePointsWebhook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ChangePointsWebhook{}

// ChangePointsWebhook struct for ChangePointsWebhook
type ChangePointsWebhook struct {
	TransactionId string `json:"transaction_id"`
	ConversationId string `json:"conversation_id"`
	ContactId string `json:"contact_id"`
	CurrentAmount int32 `json:"current_amount"`
	ChannelId string `json:"channel_id"`
}

// NewChangePointsWebhook instantiates a new ChangePointsWebhook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewChangePointsWebhook(transactionId string, conversationId string, contactId string, currentAmount int32, channelId string) *ChangePointsWebhook {
	this := ChangePointsWebhook{}
	this.TransactionId = transactionId
	this.ConversationId = conversationId
	this.ContactId = contactId
	this.CurrentAmount = currentAmount
	this.ChannelId = channelId
	return &this
}

// NewChangePointsWebhookWithDefaults instantiates a new ChangePointsWebhook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewChangePointsWebhookWithDefaults() *ChangePointsWebhook {
	this := ChangePointsWebhook{}
	return &this
}

// GetTransactionId returns the TransactionId field value
func (o *ChangePointsWebhook) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *ChangePointsWebhook) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *ChangePointsWebhook) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetConversationId returns the ConversationId field value
func (o *ChangePointsWebhook) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *ChangePointsWebhook) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *ChangePointsWebhook) SetConversationId(v string) {
	o.ConversationId = v
}

// GetContactId returns the ContactId field value
func (o *ChangePointsWebhook) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *ChangePointsWebhook) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *ChangePointsWebhook) SetContactId(v string) {
	o.ContactId = v
}

// GetCurrentAmount returns the CurrentAmount field value
func (o *ChangePointsWebhook) GetCurrentAmount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.CurrentAmount
}

// GetCurrentAmountOk returns a tuple with the CurrentAmount field value
// and a boolean to check if the value has been set.
func (o *ChangePointsWebhook) GetCurrentAmountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CurrentAmount, true
}

// SetCurrentAmount sets field value
func (o *ChangePointsWebhook) SetCurrentAmount(v int32) {
	o.CurrentAmount = v
}

// GetChannelId returns the ChannelId field value
func (o *ChangePointsWebhook) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *ChangePointsWebhook) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *ChangePointsWebhook) SetChannelId(v string) {
	o.ChannelId = v
}

func (o ChangePointsWebhook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ChangePointsWebhook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["current_amount"] = o.CurrentAmount
	toSerialize["channel_id"] = o.ChannelId
	return toSerialize, nil
}

type NullableChangePointsWebhook struct {
	value *ChangePointsWebhook
	isSet bool
}

func (v NullableChangePointsWebhook) Get() *ChangePointsWebhook {
	return v.value
}

func (v *NullableChangePointsWebhook) Set(val *ChangePointsWebhook) {
	v.value = val
	v.isSet = true
}

func (v NullableChangePointsWebhook) IsSet() bool {
	return v.isSet
}

func (v *NullableChangePointsWebhook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableChangePointsWebhook(val *ChangePointsWebhook) *NullableChangePointsWebhook {
	return &NullableChangePointsWebhook{value: val, isSet: true}
}

func (v NullableChangePointsWebhook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableChangePointsWebhook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


